package dev.shadowsoffire.apotheosis.ench.enchantments.masterwork;

import java.util.ArrayDeque;
import dev.shadowsoffire.apotheosis.util.BlockUtil;
import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
import java.util.Queue;
import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
import net.minecraft.server.level.ServerLevel;
import java.util.UUID;
import java.util.Iterator;
import net.minecraft.tags.BlockTags;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import java.util.function.BooleanSupplier;
import dev.shadowsoffire.placebo.util.PlaceboTaskQueue;
import net.minecraft.server.level.ServerPlayer;
import net.minecraftforge.event.level.BlockEvent;
import net.minecraftforge.common.ToolActions;
import net.minecraft.world.item.ItemStack;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.EquipmentSlot;
import dev.shadowsoffire.apotheosis.ench.EnchModule;
import net.minecraft.world.item.enchantment.Enchantment;

public class ChainsawEnchant extends Enchantment
{
    public ChainsawEnchant() {
        super(Enchantment.Rarity.VERY_RARE, EnchModule.AXE, new EquipmentSlot[] { EquipmentSlot.MAINHAND });
    }
    
    public int m_6586_() {
        return 1;
    }
    
    public int m_6183_(final int level) {
        return 55;
    }
    
    public int m_6175_(final int enchantmentLevel) {
        return 200;
    }
    
    public Component m_44700_(final int level) {
        return (Component)((MutableComponent)super.m_44700_(level)).m_130940_(ChatFormatting.DARK_GREEN);
    }
    
    public boolean canApplyAtEnchantingTable(final ItemStack stack) {
        return stack.canPerformAction(ToolActions.AXE_DIG) || super.canApplyAtEnchantingTable(stack);
    }
    
    public void chainsaw(final BlockEvent.BreakEvent e) {
        final Player player = e.getPlayer();
        final Level level = player.m_9236_();
        final ItemStack stack = player.m_21205_();
        final int enchLevel = stack.getEnchantmentLevel((Enchantment)this);
        if (player.getClass() == ServerPlayer.class && enchLevel > 0 && !level.f_46443_ && this.isTree(level, e.getPos(), e.getState()) && !player.m_150110_().f_35937_) {
            PlaceboTaskQueue.submitTask("apotheosis:chainsaw_task", (BooleanSupplier)new ChainsawTask(player.m_20148_(), stack, level, e.getPos()));
        }
    }
    
    private boolean isTree(final Level level, BlockPos pos, BlockState state) {
        if (!state.m_204336_(BlockTags.f_13106_)) {
            return false;
        }
        while (state.m_204336_(BlockTags.f_13106_)) {
            state = level.m_8055_(pos = pos.m_7494_());
        }
        for (final BlockPos p : BlockPos.m_121940_(pos.m_7918_(-2, -2, -2), pos.m_7918_(2, 2, 2))) {
            if (level.m_8055_(p).m_204336_(BlockTags.f_13035_)) {
                return true;
            }
        }
        return false;
    }
    
    private static class ChainsawTask implements BooleanSupplier
    {
        UUID owner;
        ItemStack axe;
        ServerLevel level;
        Int2ObjectMap<Queue<BlockPos>> hits;
        int ticks;
        
        public ChainsawTask(final UUID owner, final ItemStack axe, final Level level, final BlockPos pos) {
            this.hits = (Int2ObjectMap<Queue<BlockPos>>)new Int2ObjectOpenHashMap();
            this.ticks = 0;
            this.owner = owner;
            this.axe = axe;
            this.level = (ServerLevel)level;
            ((Queue)this.hits.computeIfAbsent(pos.m_123342_(), i -> new ArrayDeque())).add(pos);
        }
        
        @Override
        public boolean getAsBoolean() {
            if (++this.ticks % 2 != 0) {
                return false;
            }
            if (this.axe.m_41619_()) {
                return true;
            }
            final int minY = this.hits.keySet().intStream().min().getAsInt();
            final Queue<BlockPos> queue = (Queue<BlockPos>)this.hits.get(minY);
            int breaks = 0;
            while (!queue.isEmpty()) {
                final BlockPos pos = queue.poll();
                for (final BlockPos p : BlockPos.m_121940_(pos.m_7918_(-1, 0, -1), pos.m_7918_(1, 1, 1))) {
                    if (p.equals((Object)pos)) {
                        continue;
                    }
                    final BlockState state = this.level.m_8055_(p);
                    if (!state.m_204336_(BlockTags.f_13106_)) {
                        continue;
                    }
                    BlockUtil.breakExtraBlock(this.level, p, this.axe, this.owner);
                    if (this.level.m_8055_(p).m_204336_(BlockTags.f_13106_)) {
                        continue;
                    }
                    ((Queue)this.hits.computeIfAbsent(p.m_123342_(), i -> new ArrayDeque())).add(p.m_7949_());
                    ++breaks;
                }
                if (breaks > 5) {
                    break;
                }
            }
            if (queue.isEmpty()) {
                this.hits.remove(minY);
            }
            return this.hits.isEmpty();
        }
    }
}
